#############################################################################
# burn.tcl Copyright 2004, 2005 r0lZ
# DVD Burn stuff, using MkISOFS and ImgBurn.
#
# This file is part of PgcEdit.
#
# PgcEdit is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# PgcEdit is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#############################################################################

namespace eval ::burn {

proc setup {parentwin} {
	if {[info exists ::burn::layer_break_sector] && $::burn::layer_break_sector == 0} {
		set ::burn::layer_break_sector 2092896
	}
	set utiltitle "PgcEdit: Burn DVD - Setup"
	set w .burnsetup
	if {[winfo exists $w]} {bell; return}
	toplevel $w -class Dialog
	wm withdraw $w
	wm title $w $utiltitle
	if {$::config(tk) != "aqua"} {wm transient $w $parentwin}
	if {$::tcl_platform(platform) == "windows"} {catch {wm attributes $w -toolwindow 1}}
	wm protocol $w WM_DELETE_WINDOW {set ::burn::setup_done 0}
	bind $w <Escape> "set ::burn::setup_done 0"
	bind $w <Return> "set ::burn::setup_done 1"

	if {$::tcl_platform(platform) == "windows"} {
		frame  $w.f1 -bd 2 -relief groove
		pack   $w.f1 -fill x -padx 4 -pady 2
		label  $w.f1.lab -text "Required :  mkisofs.exe is part of ImgTool Classic (not ImgTool Burn!)\nYou need mkisofs version 2.01 or more!" -justify left
		pack   $w.f1.lab -side top -anchor w
		frame  $w.f1.f
		pack   $w.f1.f -fill x -pady 2 -anchor w
		label  $w.f1.f.lab -text "Path to mkisofs.exe:"
		pack   $w.f1.f.lab -side left
		entry  $w.f1.f.mkisofs -textvariable ::burn::tmp_mkisofspath
		pack   $w.f1.f.mkisofs -side left -fill x -expand 1 -padx 2
		button $w.f1.f.browse -text "..." -pady 0 -command "set tmp \[tk_getOpenFile -filetypes {{{Program files} {*.EXE}}} -initialdir [file dirname \"\$::burn::tmp_mkisofspath\"] -initialfile [file tail \"\$::burn::tmp_mkisofspath\"] -parent $w -title {Burn DVD: mkisofs.exe path}\]; if {\$tmp != {}} {set ::burn::tmp_mkisofspath \[file nativename \$tmp\]}"
		pack   $w.f1.f.browse -side left -fill y -padx 2
		frame  $w.f1.f2
		pack   $w.f1.f2
		button $w.f1.f2.dl -text " Download ImgTool Classic (free) " -pady 0 -command {
		catch {::main::display_html "http://www.coujo.de/ib/index.php?act=html_include&incl_name=download"}}
		pack   $w.f1.f2.dl -padx 2 -pady 2 -side left
		button $w.f1.f2.ver -text "Check Version" -pady 0 -command {::burn::mkisofs_version $::burn::tmp_mkisofspath true}
		pack   $w.f1.f2.ver -padx 2 -pady 2 -side left

		frame  $w.f2 -bd 2 -relief groove
		pack   $w.f2 -fill x -padx 4 -pady 2
		label  $w.f2.lab -text "Optional:  Allow you to burn the ISO image with ImgBurn\nImgBurn is highly recommended to burn the ISO!" -justify left
		pack   $w.f2.lab -side top -anchor w
		frame  $w.f2.f
		pack   $w.f2.f -fill x -pady 2 -anchor w
		label  $w.f2.f.lab1 -text "Path to ImgBurn.exe:"
		pack   $w.f2.f.lab1 -side left
		entry  $w.f2.f.ibp -textvariable ::burn::tmp_imgburnpath
		pack   $w.f2.f.ibp -side left -fill x -expand 1 -padx 2
		button $w.f2.f.browse -text "..." -pady 0 -command "set tmp \[tk_getOpenFile -filetypes {{{Program files} {*.EXE}}} -initialdir [file dirname \"\$::burn::tmp_imgburnpath\"] -initialfile [file tail \"\$::burn::tmp_imgburnpath\"] -parent $w -title {Burn DVD: ImgBurn.exe (or DVDDecrypter.exe) path}\]; if {\$tmp != {}} {set ::burn::tmp_imgburnpath \[file nativename \$tmp\]}"
		pack   $w.f2.f.browse -side left -fill y -padx 2
		button $w.f2.dl -text "  Download ImgBurn (free)  " -width 40 -pady 0 -command {
				catch {::main::display_html "http://www.imgburn.com"}}
		pack   $w.f2.dl -padx 2 -pady 2

		frame  $w.f4 -bd 2 -relief groove
		pack   $w.f4 -fill x -padx 4 -pady 2
		label  $w.f4.lab -text "Optional :  Allow you to mount the ISO image with Daemon-Tools\n(Doesn't work when the Split ISO image option below is checked)" -justify left
		pack   $w.f4.lab -side top -anchor w
		frame  $w.f4.f
		pack   $w.f4.f -fill x -pady 2 -anchor w
		label  $w.f4.f.lab1 -text "Path to daemon.exe:"
		pack   $w.f4.f.lab1 -side left
		entry  $w.f4.f.ibp -textvariable ::burn::tmp_daemonpath
		pack   $w.f4.f.ibp -side left -fill x -expand 1 -padx 2
		button $w.f4.f.browse -text "..." -pady 0 -command "set tmp \[tk_getOpenFile -filetypes {{{Program files} {*.EXE}}} -initialdir [file dirname \"\$::burn::tmp_daemonpath\"] -initialfile [file tail \"\$::burn::tmp_daemonpath\"] -parent $w -title {Burn DVD: daemon.exe path}\]; if {\$tmp != {}} {set ::burn::tmp_daemonpath \[file nativename \$tmp\]}"
		pack   $w.f4.f.browse -side left -fill y -padx 2

		if {!$::config(illegal_aps)} {
			button $w.f4.dl -text "Download Daemon-Tools (free)" -width 40 -pady 0 -command {
				catch {::main::display_html "http://www.daemon-tools.cc/dtcc/portal/download.php?mode=ViewCategory&catid=5"}}
			pack   $w.f4.dl -padx 2 -pady 2
		}	
		checkbutton $w.split -variable ::burn::tmp_splitoutput -anchor w -onvalue "-split-output" -offvalue "" \
				-text "Split ISO image into 1GB chunks - Required for FAT32 partitions (Win95/98/ME)!"
		pack   $w.split -fill x -pady 2
	
		frame  $w.f3
		pack   $w.f3 -fill x -padx 2 -pady 2
		label  $w.f3.lab1 -text "DVD Burner drive letter: " -anchor w
		tk_optionMenu $w.f3.mb ::burn::tmp_burnerletter D: E: F: G: H: I: J: K: L: M: N: O: P: Q: R: S: T: U: V: W: X: Y: Z:
		pack   $w.f3.lab1 -side left
		pack   $w.f3.mb -side left
	} else {
		frame  $w.fl -bd 2 -relief groove
		pack   $w.fl -fill x -padx 4 -pady 4
		set txt "mkisofs 2.01 or more is needed."
		if {$::config(platform) == "mac"} {
			set txt "$txt\nmkisofs is included in the Mac PgcEdit Starter app v5 or more.\nIf you don't use the starter app, you need to copy it in your path."
		} else {
			set txt "$txt  It should already be in your path."
		}
		label  $w.fl.lab -text $txt -justify left
		pack   $w.fl.lab -side top -anchor w
		button $w.fl.ver -text "Check mkisofs availability and version number" -pady 0 \
				-command {::burn::mkisofs_version mkisofs true}
		pack   $w.fl.ver -padx 2 -pady 2 -fill x -side top
	}

	frame  $w.f5 -bd 2 -relief groove
	pack   $w.f5 -fill x -padx 4 -pady 2
	frame  $w.f5.f
	pack   $w.f5.f -side left
	if {$::tcl_platform(platform) == "windows"} {
		frame  $w.f5.f.pad1 -height 4
		button $w.f5.f.chk -text "Check free/L0 sectors of your +/-R blank media with ImgBurn in ISO mode..." \
				-pady 0 -command {if {[catch {exec -- $::burn::tmp_imgburnpath /MODE ISOWRITE &}]} {bell; focus .burnsetup.f2.f.ibp}}
		label  $w.f5.f.lab1 -justify left -text \
				"... and copy/paste the Free Sectors value in the right field below.\nFor +R media, you can always use the +R presets, because the +R size is fixed."
	} else {
		label  $w.f5.f.lab1 -justify left -text \
				"Check free sectors of your -R blank media and fill in the right field below.\nFor +R media, you can always use the +R presets, because the +R size is fixed."
	}
	label  $w.f5.f.l1_1 -text "Number of sectors in a single layer DVD:"
	entry  $w.f5.f.ent1 -textvariable ::burn::tmp_sldisksize -width 8 -justify right
	menubutton $w.f5.f.but1 -text "Presets" -menu $w.f5.f.but1.mnu -pady 1 -indicatoron true
	menu $w.f5.f.but1.mnu -tearoff false
	$w.f5.f.but1.mnu add radiobutton -variable ::burn::tmp_sldisksize -value 2295104 -label "DVD+R (2295104) - Default" \
			-command {set ::burn::tmp_sldisksize 2295104}
	$w.f5.f.but1.mnu add radiobutton -variable ::burn::tmp_sldisksize -value 2297888 -label "DVD-R (2297888)" \
			-command {set ::burn::tmp_sldisksize 2297888}
	$w.f5.f.but1.mnu add radiobutton -variable ::burn::tmp_sldisksize -value 358400  -label "Mini DVD on CD 700Mb (358400)" \
			-command {set ::burn::tmp_sldisksize 358400}
	$w.f5.f.but1.mnu add radiobutton -variable ::burn::tmp_sldisksize -value 327680  -label "Mini DVD on CD 650Mb (327680)" \
			-command {set ::burn::tmp_sldisksize 327680}
	label  $w.f5.f.l1_2 -text "2295104 for a DVD+R, or approx 2297888 for a DVD-R.  MUST be a multiple of 16!" -pady 0
	frame  $w.f5.f.pad2 -height 4
	label  $w.f5.f.l2_1 -text "Number of sectors in a double layer DVD:"
	entry  $w.f5.f.ent2 -textvariable ::burn::tmp_dldisksize -width 8 -justify right
	menubutton $w.f5.f.but2 -text "Presets" -menu $w.f5.f.but2.mnu -pady 1 -indicatoron true
	menu $w.f5.f.but2.mnu -tearoff false
	$w.f5.f.but2.mnu add radiobutton -variable ::burn::tmp_dldisksize -value 4173824 -label "DL DVD+R (4173824) - Default" \
			-command {set ::burn::tmp_dldisksize 4173824}
	$w.f5.f.but2.mnu add radiobutton -variable ::burn::tmp_dldisksize -value 4150400 -label "DL DVD-R (4150400)" \
			-command {set ::burn::tmp_dldisksize 4150400}
	label  $w.f5.f.l2_2 -text "4173824 for a DVD+R, or approx 4150400 for a DVD-R.  MUST be a multiple of 32!" -pady 0

	frame  $w.f5.f.pad3 -height 4
	label  $w.f5.f.l3_1 -text "DL DVD-R Layer 0 Data Zone Capacity:"
	entry  $w.f5.f.ent3 -textvariable ::burn::tmp_forcedlb -width 8 -justify right
	menubutton $w.f5.f.but3 -text "Presets" -menu $w.f5.f.but3.mnu -pady 1 -indicatoron true
	menu $w.f5.f.but3.mnu -tearoff false
	$w.f5.f.but3.mnu add radiobutton -variable ::burn::tmp_forcedlb -value 2092896 -label "2092896" \
			-command {set ::burn::tmp_forcedlb 2092896}
	label  $w.f5.f.l3_2 -text "This value is required when burning a Dual Layer DVD-R, and is dependent of the\nDL DVD-R media you use.  Please use the \"L0 Data Zone Capacity\" value available\nin the ImgBurn info window!  (This value is ingored for Single Layer and +R media.)" -pady 0 -justify left

	if {$::tcl_platform(platform) == "windows"} {
		grid   $w.f5.f.pad1 -row 0 -column 0
		grid   $w.f5.f.chk  -row 1 -column 0 -sticky sew -columnspan 4
		grid   configure $w.f5.f.chk -padx 4
		grid   columnconfigure $w.f5.f 1 -pad 4
	}
	grid   $w.f5.f.lab1 -row 2 -column 0 -sticky w  -columnspan 4
	grid   $w.f5.f.l1_1 -row 3 -column 0 -sticky w
	grid   $w.f5.f.ent1 -row 3 -column 1 -sticky w
	grid   $w.f5.f.but1 -row 3 -column 2 -sticky w
	grid   $w.f5.f.l1_2 -row 4 -column 0 -sticky w -columnspan 4
	grid   $w.f5.f.pad2 -row 5 -column 0
	grid   $w.f5.f.l2_1 -row 6 -column 0 -sticky w
	grid   $w.f5.f.ent2 -row 6 -column 1 -sticky w
	grid   $w.f5.f.but2 -row 6 -column 2 -sticky w
	grid   $w.f5.f.l2_2 -row 7 -column 0 -sticky w -columnspan 4
	grid   $w.f5.f.pad3 -row 8 -column 0
	grid   $w.f5.f.l3_1 -row 9 -column 0 -sticky w
	grid   $w.f5.f.ent3 -row 9 -column 1 -sticky w
	grid   $w.f5.f.but3 -row 9 -column 2 -sticky w
	grid   $w.f5.f.l3_2 -row 10 -column 0 -sticky w -columnspan 4
	grid   columnconfigure $w.f5.f 3 -weight 1 


	# buttons
	frame  $w.fb
	pack   $w.fb -padx 2 -pady 4 -anchor e
	button $w.fb.ok -text "Save" -width 10 -command {set ::burn::setup_done 1}
	pack   $w.fb.ok -side left -padx 2
	button $w.fb.use -text "Use" -width 10 -command {set ::burn::setup_done 2}
	pack   $w.fb.use -side left -padx 4
	button $w.fb.cancel -text "Cancel" -width 10 -command {set ::burn::setup_done 0}
	pack   $w.fb.cancel -side left -padx 2

	if {$::tcl_platform(platform) == "windows"} {
		set ::burn::tmp_mkisofspath [file nativename [file normalize $::burn::mkisofspath]]
		set ::burn::tmp_imgburnpath [file nativename [file normalize $::burn::imgburnpath]]
		set ::burn::tmp_daemonpath [file nativename [file normalize $::burn::daemonpath]]
		set ::burn::tmp_splitoutput $::burn::splitoutput
		set ::burn::tmp_burnerletter $::burn::burnerletter
	}
	set ::burn::tmp_sldisksize $::burn::sldisksize
	set ::burn::tmp_dldisksize $::burn::dldisksize
	set ::burn::tmp_forcedlb   $::burn::layer_break_sector

	update
	wm minsize $w [winfo reqwidth $w] [winfo reqheight $w]
	wm maxsize $w [winfo reqwidth $w] [winfo reqheight $w]
	wm resizable $w 0 0
	set wx [expr {[winfo rootx .]+(([winfo width  .]-[winfo reqwidth  $w])/2)}]
	set wy [expr {[winfo rooty .]+(([winfo height .]-[winfo reqheight $w])/2)-25}]
	if {$wx < 10} {set wx 10}
	if {$wy < 22} {set wy 22}
	wm geometry $w +$wx+$wy
	wm deiconify $w
	focus $w
	grab set $w

	set ok false
	while {! $ok} {
		tkwait variable ::burn::setup_done
	
		if {$::burn::setup_done > 0} {
			set tmp1 [string map {, ""} $::burn::tmp_sldisksize]
			if {![string is integer $tmp1]} {
				bell
				focus $w.f5.f.ent1
				continue
			}
			set tmp2 [string map {, ""} $::burn::tmp_dldisksize]
			if {![string is integer $tmp2]} {
				bell
				focus $w.f5.f.ent2
				continue
			}
			set tmp3 [string map {, ""} $::burn::tmp_forcedlb]
			if {![string is integer $tmp3]} {
				bell
				focus $w.f5.f.ent3
				continue
			}
			set ::burn::sldisksize $tmp1
			set ::burn::dldisksize $tmp2
			set ::burn::layer_break_sector $tmp3
			if {$::tcl_platform(platform) == "windows"} {
				set ::burn::mkisofspath [file nativename [file normalize $::burn::tmp_mkisofspath]]
				set ::burn::imgburnpath [file nativename [file normalize $::burn::tmp_imgburnpath]]
				set ::burn::daemonpath [file nativename [file normalize $::burn::tmp_daemonpath]]
				set ::burn::splitoutput $::burn::tmp_splitoutput
				set ::burn::burnerletter $::burn::tmp_burnerletter
			}

			set ok true
			if {[winfo exists .burn]} {
				validate_burn
		
				set dvdromsizelist [dvd_rom_size [file dirname $::dvddir]]
				set dvdromsize [expr [lindex $dvdromsizelist 0]+[lindex $dvdromsizelist 1]]
				set sectors [expr {[::writedvd::DVD_sectors] + $dvdromsize}]
				set txtlist [::writedvd::DVD_size_text $sectors $dvdromsize]
				.burn.sf.size1 configure -text [lindex $txtlist 0] -justify left
				.burn.sf.size2 configure -text [lindex $txtlist 1] -justify left
				.burn.sf.size3 configure -text [lindex $txtlist 3] -justify left
				.burn.sf.pc1   configure -text [lindex $txtlist 2]
				.burn.sf.pc2   configure -text [lindex $txtlist 4]
				if {$sectors > $::burn::sldisksize} {
					.burn.sf.pc1 configure -foreground red
				} else {
					.burn.sf.pc1 configure -foreground black
				}
				if {$sectors > $::burn::dldisksize} {
					.burn.sf.pc2 configure -foreground red
				} else {
					.burn.sf.pc2 configure -foreground black
				}
			}

			if {$::burn::setup_done == 1} {
				save_setups
			}
		} else {
			set ok true
		}
		grab release $w
		destroy $w
		#grab set $parentwin
	}
}

proc burn {} {
	if {[info exists ::burn::layer_break_sector]} {
		if {$::burn::layer_break_sector == 0} {
			set ::burn::layer_break_sector 2092896
		}
	}
	if {! [info exists ::dvddir]} {bell; return}
	if {[info exists ::burn::processing] && $::burn::processing} {bell; return}
	set ::burn::processing false

	if {$::dvd_modified} {
		set r [tk_messageBox -title "PgcEdit: Burn DVD" -icon warning \
				-message "DVD modified but not saved!\n\nThe DVD will be burned with the\nfiles currently saved on disk.\n\nContinue?" \
				-parent . -type yesno -default no]
		if {$r == "no"} {
			return
		}
		set dvdmodifiedwarning "\n\nWarning: DVD modified but not saved!"
	} else {
		set dvdmodifiedwarning ""
	}

	set in [file nativename [file normalize $::dvddir]]
	if {[file tail $in] == "VIDEO_TS"} {
		set in [file dirname $in]
	} else {
		set txt "WARNING: The DVD files must be in a VIDEO_TS subfolder.\n\n"
		set txt "${txt}Do you want to move the DVD files (and the PgcEdit_backup)\n"
		set txt "${txt}in a new VIDEO_TS subfolder?"
		set txt "${txt}$dvdmodifiedwarning"
		set r [tk_messageBox -title "PgcEdit: Burn DVD" -icon warning \
				-message $txt -parent . -type yesno -default yes]
		if {$r == "no"} {
			::macros::explore_dvd
			return
		} else {
			set files [glob -tails -directory "$::dvddir" V*TS*]
			set newdir [file join $::dvddir VIDEO_TS]
			if {[makedir $newdir "PgcEdit: Burn DVD" .]} {
				return
			}
			foreach f $files {
				if {[movefile [file join $::dvddir $f] $newdir false "PgcEdit: Burn DVD" .]} {
					::macros::explore_dvd
					return
				}
			}
			set backupfiles [glob -directory $::dvddir -nocomplain -tails -- \
					*backup* *Backup* "Copy of *" .DS_Store]
			foreach f $backupfiles {
				movefile [file join $::dvddir $f] $newdir false "PgcEdit: Burn DVD" .
			}

			set ::dvddir $newdir
			if {$::config(backup_in_root)} {
				set ::backupdir [file join [file dirname $::dvddir] PgcEdit_backup]
			} else {
				set ::backupdir [file join $::dvddir PgcEdit_backup]
			}
			::main::set_window_title
			#::main::ReRead_DVD true

			burn
			return
		}
	}
	set in [file nativename [file normalize $in]]
	set id [::utils::get_General_Name]
	if {$id == ""} {
		set vname [file tail $::dvddir]
		if {$vname == "VIDEO_TS"} {
			set vname [file tail [file dirname $::dvddir]]
		}
		set id $vname
	}
	set id2 ""
	set underscore true
	for {set i 0} {$i < 32} {incr i} {
		set c [string range $id $i $i]
	if {[string is alnum $c]} {
			set id2 $id2$c
			set underscore false
		} else {
			if {! $underscore} {
				set id2 ${id2}_
			}
			set underscore true
		}
	}
	set ::burn::id [string range [string toupper [string trim $id2 _]] 0 31]
	set ::burn::status ""

	set ::burn::out [file nativename [file normalize [file join [file dirname $::burn::out] ${::burn::id}.ISO]]]

	set utiltitle "PgcEdit: Burn DVD"
	set w .burn
	if {[winfo exists $w]} {bell; return}
	toplevel $w -class Dialog -menu $w.setupmenu
	wm withdraw $w
	wm title $w $utiltitle
	if {$::config(tk) != "aqua"} {wm transient $w .}
	if {$::tcl_platform(platform) == "windows"} {catch {wm attributes $w -toolwindow 1}}
	wm protocol $w WM_DELETE_WINDOW {set ::burn::burn_done 0}
	bind $w <Escape> "set ::burn::burn_done 0"
	bind $w <Return> "set ::burn::burn_done 1"

	menu $w.setupmenu
	$w.setupmenu add command -label Setup -command {::burn::setup .burn}

	set dvdromsizelist [dvd_rom_size $in]
	set dvdromsize [expr [lindex $dvdromsizelist 0]+[lindex $dvdromsizelist 1]]
	set sectors [expr {[::writedvd::DVD_sectors] + $dvdromsize}]
	set txtlist [::writedvd::DVD_size_text $sectors $dvdromsize]

	set gaptext "Use 32KB gaps option is currently "
	if {$::config(save_BUP_with_gaps)} {
		set gaptext ${gaptext}ON
		set gaptexthighlight darkgreen
	} else {
		set gaptext ${gaptext}OFF
		set gaptexthighlight red
	}
	frame  $w.sf -bd 2 -relief groove
	pack   $w.sf -fill x -padx 4 -pady 4
	label  $w.sf.size1 -text [lindex $txtlist 0] -justify left
	label  $w.sf.size2 -text [lindex $txtlist 1] -justify left
	label  $w.sf.size3 -text [lindex $txtlist 3] -justify left

	label  $w.sf.gap -text $gaptext
	label  $w.sf.pc1 -text [lindex $txtlist 2]
	label  $w.sf.pc2 -text [lindex $txtlist 4]
	grid   $w.sf.size1 -row 0 -column 0 -sticky w
	grid   $w.sf.size2 -row 0 -column 1 -sticky w
	grid   $w.sf.size3 -row 0 -column 2 -sticky w
	grid   $w.sf.gap   -row 1 -column 0 -sticky w
	grid   $w.sf.pc1   -row 1 -column 1 -sticky w
	grid   $w.sf.pc2   -row 1 -column 2 -sticky w
	grid columnconfigure $w.sf 0 -weight 1
	grid columnconfigure $w.sf 1 -weight 1
	grid columnconfigure $w.sf 2 -weight 1
	if {$sectors > $::burn::sldisksize} {
		$w.sf.pc1 configure -foreground red
	}
	if {$sectors > $::burn::dldisksize} {
		$w.sf.pc2 configure -foreground red
	}
	$w.sf.gap configure -foreground $gaptexthighlight

	frame  $w.opts -bd 2 -relief groove
	pack   $w.opts -padx 4 -pady 2
	frame  $w.opts.f2
	pack   $w.opts.f2 -fill x -padx 4 -pady 4
	label  $w.opts.f2.lab -text "Output ISO:" -width 12 -anchor w
	pack   $w.opts.f2.lab -side left
	entry  $w.opts.f2.id -width 70 -textvariable ::burn::out
	pack   $w.opts.f2.id -side left -fill x
	frame  $w.opts.f2.pad -width 4
	pack   $w.opts.f2.pad -side left
	button $w.opts.f2.browse -text "..." -pady 0 -command "set out \[tk_getSaveFile -filetypes {{{ISO Image files} {*.ISO}}} -initialdir [file dirname \"\$::burn::out\"] -initialfile [file tail \"\$::burn::out\"] -parent $w -title {Burn DVD: ISO image filename}\]; if {\$out != {}} {set ::burn::out \[file nativename \$out\]}"
	pack   $w.opts.f2.browse -side left -fill y

	frame  $w.opts.f1
	pack   $w.opts.f1 -fill x -padx 4 -pady 2
	label  $w.opts.f1.lab -text "Volume Label:" -width 12 -anchor w
	pack   $w.opts.f1.lab -side left
	entry  $w.opts.f1.id -width 32 -textvariable ::burn::id -validatecommand "::burn::validate_id_entry %P" -validate all
	pack   $w.opts.f1.id -fill x

	checkbutton $w.opts.showlog -variable ::burn::showlog -text "Always show ISO creation log  (Will be shown anyway in case of error)" \
			-anchor w -onvalue true -offvalue false
	pack   $w.opts.showlog -fill x -padx 2

	if {$::tcl_platform(platform) == "windows"} {
		frame  $w.opts.fmount
		pack   $w.opts.fmount -fill x -padx 2
		checkbutton $w.opts.fmount.mount -variable ::burn::mount -text "Mount ISO image using Daemon-Tools, as device" \
				-anchor w -onvalue true -offvalue false -command ::burn::validate_burn
		tk_optionMenu $w.opts.fmount.device ::burn::mount_device 0 1 2 3
		label  $w.opts.fmount.lab -text " (Warning : The device must be enabled!)"
		pack   $w.opts.fmount.mount -fill x -side left
		pack   $w.opts.fmount.device -side left
		pack   $w.opts.fmount.lab -side left
	
		checkbutton $w.opts.burn -variable ::burn::burn -text "Burn ISO image using ImgBurn:" \
				-anchor w -command ::burn::validate_burn -onvalue true -offvalue false

		frame  $w.opts.bo -bd 2 -relief groove
		frame  $w.opts.bo.sp
		label  $w.opts.bo.sp.l -text "Burn speed:"
		tk_optionMenu $w.opts.bo.sp.speed ::burn::speed 1x 2x 2.4x 2,4x 4x 8x 12x 16x MAX

		label  $w.opts.bo.sp.pad -text "           "
		label  $w.opts.bo.sp.l2 -text "DL media type:"
		tk_optionMenu $w.opts.bo.sp.media ::burn::media "Double layer DVD+R" "Dual layer DVD-R"
		::balloon::set_balloon $w.opts.bo.sp.media "Ignored when burning\nsingle layer DVD+/-R."

		checkbutton $w.opts.bo.start -variable ::burn::start -text "Start burn immediately" -anchor w -onvalue "/START" -offvalue ""
		checkbutton $w.opts.bo.eraserw -variable ::burn::eraserw -text "Erase non empty RW media" -anchor w -onvalue "/ERASE" -offvalue ""
		checkbutton $w.opts.bo.verify -variable ::burn::verify -text "Verify written DVD" -anchor w -onvalue YES -offvalue NO
		checkbutton $w.opts.bo.del -variable ::burn::deleteimage -text "Delete ISO image when done" -anchor w -onvalue YES -offvalue NO
		checkbutton $w.opts.bo.close -variable ::burn::close -text "Close ImgBurn when done (also in case of error!)" -anchor w -onvalue "/CLOSE" -offvalue ""
		checkbutton $w.opts.bo.shutdown -variable ::burn::shutdown -text "Shutdown computer after burning (and close PgcEdit after ISO creation)" -anchor w -onvalue "/SHUTDOWN" -offvalue ""
		frame  $w.opts.pad -height 2

		pack   $w.opts.burn -fill x -padx 2

		pack   $w.opts.bo -fill x -padx 24
		pack   $w.opts.bo.sp -fill x -padx 2
		pack   $w.opts.bo.sp.l -side left
		pack   $w.opts.bo.sp.speed -side left
		pack   $w.opts.bo.sp.pad -side left
		pack   $w.opts.bo.sp.l2 -side left
		pack   $w.opts.bo.sp.media -side left

		pack   $w.opts.bo.start -fill x
		pack   $w.opts.bo.eraserw -fill x
		pack   $w.opts.bo.verify -fill x
		pack   $w.opts.bo.del -fill x
		pack   $w.opts.bo.close -fill x
		pack   $w.opts.bo.shutdown -fill x
		pack   $w.opts.pad
	}
	
	label  $w.status -textvariable ::burn::status
	pack   $w.status -pady 2
	canvas $w.c -width 300 -height 15 -bd 2 -relief sunken
	pack   $w.c -padx 2 -fill x
	label  $w.l0s -text " "
	pack   $w.l0s -fill x -expand 1

	# buttons
	frame  $w.fb
	pack   $w.fb -padx 2 -pady 2 -fill x
	if {$::tcl_platform(platform) == "windows"} {
		button $w.fb.dt -text "Show Daemon-Tools tray icon" -width 26 \
				-command {catch {exec -- $::burn::daemonpath &}}
		button $w.fb.dd -text "Launch ImgBurn" -width 26 \
				-command {if {[catch {exec -- $::burn::imgburnpath /MODE ISOWRITE &}]} bell}
		pack   $w.fb.dt -side left -padx 2
		::balloon::set_balloon $w.fb.dt "Use this button to setup the\nDaemon-Tools devices."
		pack   $w.fb.dd -side left -padx 2
		::balloon::set_balloon $w.fb.dd "Use this button to examine the burn\nspeeds of your blank media, or to\nchange the booktypes.\nDon't forget to close ImgBurn before\nlaunching the burn!"
	}
	label  $w.fb.pad -text " "
	pack   $w.fb.pad -side left -fill x -expand 1
	button $w.fb.ok -text "OK" -width 10 -command {set ::burn::burn_done 1}
	pack   $w.fb.ok -side left -padx 2
	button $w.fb.cancel -text "Cancel" -width 10 -command {set ::burn::burn_done 0}
	pack   $w.fb.cancel -side left -padx 2

	validate_burn

	update
	wm minsize $w [winfo reqwidth $w] [winfo reqheight $w]
	wm maxsize $w [winfo reqwidth $w] [winfo reqheight $w]
	wm resizable $w 0 0
	set wx [expr {[winfo rootx .]+(([winfo width  .]-[winfo reqwidth  $w])/2)}]
	set wy [expr {[winfo rooty .]+(([winfo height .]-[winfo reqheight $w])/2)-25}]
	if {$wx < 10} {set wx 10}
	if {$wy < 22} {set wy 22}
	wm geometry $w +$wx+$wy
	wm deiconify $w
	focus $w
	#grab set $w

	catch {trace remove variable ::burn::out write ::burn::validate_burn}
	catch {trace remove variable ::burn::id  write ::burn::validate_burn}
	trace add variable ::burn::out write ::burn::validate_burn
	trace add variable ::burn::id  write ::burn::validate_burn

	if {($::tcl_platform(platform) == "windows" || $::config(platform) == "mac") && \
			![file isfile $::burn::mkisofspath]} {
		setup .burn
	}

	# wait for user input
	set error true
	while {$error} {
		# configure burn window for input
		set ::burn::processing false
		wm protocol $w WM_DELETE_WINDOW {set ::burn::burn_done 0}
		$w.fb.ok configure -state normal
		bind $w <Return> {set ::burn::burn_done 1}
		$w.fb.cancel configure -text "Cancel" -state normal -command {set ::burn::burn_done 0}
		bind $w <Cancel> "set ::burn::burn_done 0"
		$w.opts.f2.lab configure -foreground [$w.fb.ok cget -foreground]
		$w.opts.f2.id configure -state normal
		$w.opts.f2.browse configure -state normal
		$w.opts.f1.lab configure -foreground [$w.fb.ok cget -foreground]
		$w.opts.f1.id configure -state normal
		catch {trace remove variable ::burn::out write ::burn::validate_burn}
		catch {trace remove variable ::burn::id  write ::burn::validate_burn}
		trace add variable ::burn::out write ::burn::validate_burn
		trace add variable ::burn::id  write ::burn::validate_burn
		#set ::burn::status "Ready."
		show_msg ""
		validate_burn
		if {[info exists ::burn::progressbar_item]} {
			$w.c delete $::burn::progressbar_item
		}
		set ::burn::burn_done false
		tkwait variable ::burn::burn_done
		if {!$::burn::burn_done} {
			trace remove variable ::burn::out write ::burn::validate_burn
			trace remove variable ::burn::id  write ::burn::validate_burn
			destroy $w
			return
		}

		# set internal variables
		set mkisofserror "****** ERROR returned by mkisofs! ******"
		set out $::burn::out
		set ext [string toupper [file extension $out]]
		if {$ext != ".ISO"} {
			set out ${out}.ISO
		}
		if {$::burn::splitoutput == ""} {
			set realout $out
		} else {
			set realout [file rootname $out].lst
		}
		set log [file nativename [file normalize "[file rootname $out].log"]]
		set error false

		# check for free space on disk
		if {!$error} {
			set sectorsfree [get_free_disk_space $realout]
			if {$sectorsfree < $sectors && $sectorsfree != -1} {
				set r [tk_messageBox -title "PgcEdit: Burn DVD" -icon warning \
					-message "WARNING: Not enough free space left on hard disk!\n\nContinue anyway?" \
					-parent $w -type yesno -default no]
				if {$r == "no"} {
					set error true
					continue
				}
			}
		}

		if {$sectors > $::burn::dldisksize} {
			tk_messageBox -title "PgcEdit: Burn DVD" -icon warning \
					-message "DVD size too big to fit on a DVD-9.\nPlease remove some material or shrink the DVD." \
					-parent $w
			set error true
			continue
		}

		# check overwrite existing ISO
		if {!$error} {
			if {[file exists $realout]} {
				set r [tk_messageBox -title "PgcEdit: Burn DVD" -icon warning \
					-message "WARNING: Output ISO image already exists!\n\nOverwrite?" \
					-parent $w -type yesno -default yes]
				if {$r == "no"} {
					set error true
					continue
				}
			}		
		}

		# build list of alien files to remove from the VIDEO_TS folder
		if {!$error} {
			set alienfiles [glob -tails -directory "$in/VIDEO_TS" *]
			foreach f {VIDEO_TS.IFO VIDEO_TS.VOB VIDEO_TS.BUP} {
				set idx [lsearch $alienfiles $f]
				if {$idx != -1} {
					set alienfiles [lreplace $alienfiles $idx $idx]
				}
			}
			for {set vts 1} {$vts < 100} {incr vts} {
				set basename "VTS_[format %02d $vts]_"
				foreach f [list "${basename}0.IFO" "${basename}0.BUP"] {
					set idx [lsearch $alienfiles $f]
					if {$idx != -1} {
						set alienfiles [lreplace $alienfiles $idx $idx]
					}
				}
				for {set n 0} {$n < 10} {incr n} {
					set idx [lsearch $alienfiles "${basename}$n.VOB"]
					if {$idx != -1} {
						set alienfiles [lreplace $alienfiles $idx $idx]
					}
				}
			}
			set backupfiles [glob -directory $::dvddir -nocomplain -tails -- \
					*backup* *Backup* "Copy of *" .DS_Store]
			foreach f $backupfiles {
				set idx [lsearch $alienfiles $f]
				set alienfiles [lreplace $alienfiles $idx $idx]
			}
			if {[llength $alienfiles]>0} {
				set txt "ERROR: There are [llength $alienfiles] alien files in the VIDEO_TS folder:\n"
				set txt "${txt}[string map {\{ \" \} \"} $alienfiles]\n\n"
				set txt "${txt}Please remove them before burning the DVD.\n\n"
				set txt "${txt}Note: The PgcEdit_backup, VobBlanker_backup, MenuShrinkBackup... folders\nand \"Copy of V*\" backup files are automatically excluded.\n"
				set txt "${txt}You don't need to delete them."
				tk_messageBox -title "PgcEdit: Burn DVD" -icon error \
						-message $txt \
						-parent $w -type ok
				::macros::explore_dvd
				set error true
				continue
			}
		}

		# Verify if the user wants to burn eventual DVD-ROM files
		if {!$error} {
			set alienfiles [glob -tails -directory $in *]
			set okfiles [glob -directory $in -nocomplain -tails -- \
					VIDEO_TS AUDIO_TS JACKET_P *backup* *Backup* "Copy of *" .DS_Store]
			foreach f $okfiles {
				set idx [lsearch $alienfiles $f]
				set alienfiles [lreplace $alienfiles $idx $idx]
			}
			if {[llength $alienfiles]>0} {
				if {[llength $alienfiles]==1} {
					set msg "There is one DVD-ROM file (or subfolder) in the DVD root folder:\n[string map {\{ \" \} \"} $alienfiles]\n\nAre you sure you want to burn it as well?"
				} else {
					set msg "There are [llength $alienfiles] DVD-ROM files (or subfolders) in the DVD root folder:\n[string map {\{ \" \} \"} $alienfiles]\n\nAre you sure you want to burn them as well?"
				}
				set r [tk_messageBox -title "PgcEdit: Burn DVD" -icon warning \
						-message $msg -parent $w -type yesno -default no]
				if {$r == "no"} {
					::macros::explore_dvd parent
					set error true
					continue
				}
			}
		}

		# Create AUDIO_TS
		if {!$error} {
			set error [makedir "$in/AUDIO_TS" "PgcEdit: Burn DVD" .]
		}

		if {!$error} {
			set mkisofsversionstring [mkisofs_version $::burn::mkisofspath false]
		}

		# verify ISO compatibility with mkisofs in -print-size mode
		if {!$error} {
			set txt "Testing ISO compatibility."
			set ::burn::status $txt
			show_msg "Burn DVD: $txt"
			update idletasks
			after 5 set ::burn::pause 1
			tkwait variable ::burn::pause
			catch {file delete $log}
			if {$::tcl_platform(platform) == "windows"} {
				set rc [catch {set size [exec -- $::burn::mkisofspath -dvd-video -print-size -no-pad -V $::burn::id -p PgcEdit -m *backup* -m *Backup* -m .DS_Store -m "Copy of *" $in >& $log]} errstr]
			} else {
				set rc [catch {set size [exec -- $::burn::mkisofspath -dvd-video -print-size -no-pad -V $::burn::id -p PgcEdit -m \\*backup\\* -m \\*Backup\\* -m .DS_Store -m "Copy of \\*" $in >& $log]} errstr]
			}
			if {$rc} {
				show_msg "Burn DVD: $errstr"
				set tmp [readLog $log]
				if {[string first "Invalid node - -m" $tmp] != -1} {
					set txt "mkisofs returnde the following error:\n$tmp\n\n"
					set txt "${txt}This error may be caused by the backup folders.\n"
					set txt "${txt}PgcEdit can delete the backups and continue (YES),"
					set txt "${txt}continue w/o deleting the backups (NO), or cancel.\n"
					set txt "${txt}Delete the backup and continue?"
					set r [tk_messageBox -title "PgcEdit: Burn DVD" -icon error \
							-message $txt -parent $w -type yesnocancel -default yes]
					if {$r == "no"} {
						set rc 0
					} elseif {$r == "yes"} {
						set rc 0
						set backups [glob -directory $::dvddir -nocomplain -- \
							*backup* *Backup* "Copy of *" .DS_Store]
						foreach i {$backups} {
							file delete -force $i
						}
						set backups [glob -directory [file dirname $::dvddir] -nocomplain -- \
							*backup* *Backup* "Copy of *" .DS_Store]
						foreach i {$backups} {
							file delete -force $i
						}
					}
				}
			}
			if {$rc} {
				if {[file exists $log]} {
					bell
					set logout [log_header $in $mkisofsversionstring]
					set logout $logout[readLog $log]
					set logout "$logout\nError creating ISO:\n$errstr\n"
					set logout "$logout\nTest command was:\n"
					set logout "$logout\n\"$::burn::mkisofspath\" -dvd-video -print-size -no-pad -V \"$::burn::id\" -p \"PgcEdit\" -m \"*backup*\" -m \"*Backup*\" -m .DS_Store -m \"Copy of *\" \"$in\""
					::main::showtext .burnlog "PgcEdit Burn DVD - ISO creation log" $logout
					file delete $log
				} else {
					tk_messageBox -title "PgcEdit: Burn DVD" -icon error \
							-message "Error creating ISO:\n$errstr" -parent $w -type ok
				}
				set error true
				continue
			}
		}

		# all preparation checks completed.  Return to input mode if error
		if {$error} continue

		# configure burn window for burning
		if {!$error} {			
			$w.fb.ok configure -state disabled
			$w.fb.cancel configure -state disabled
			bind $w <Escape> {}
			bind $w <Return> {}
			$w.opts.f2.lab configure -foreground [$w.fb.ok cget -disabledforeground]
			$w.opts.f2.id configure -state disabled
			$w.opts.f2.browse configure -state disabled
			$w.opts.f1.lab configure -foreground [$w.fb.ok cget -disabledforeground]
			$w.opts.f1.id configure -state disabled
		}

		### Double Layer stuff
		set burndl false
		set ::burn::absoffset 0
		set ::burn::true_absoffset 0
		# TODO: remove || $::config(debug)
		if {!$error && $sectors > $::burn::sldisksize} {
			set burndl true
			set txt "Setting Layer Break..."
			set ::burn::status $txt
			show_msg "Burn DVD: $txt"

			# Find the first sector of the VIDEO_TS.IFO file.
			# We do that by generation the ISO image, parsing it while it is generated.
			# When "DVDVIDEO-VMG" is found at the start of a block, we remember the block number,
			# then we kill mkisofs, and continue.
			set bat [file normalize [file join $::config(tempdir) "MakeISO.bat"]]
			if {$::tcl_platform(platform) == "windows"} {
				set cmd "@echo off\n"
				set cmd "${cmd}\"$::burn::mkisofspath\" -dvd-video -no-pad -V \"$::burn::id\" -p PgcEdit -m *backup* -m *Backup* -m .DS_Store -m \"Copy of *\" \"$in\"\n"
			} else {
				set cmd "#!/bin/sh\n"
				set cmd "${cmd}\"$::burn::mkisofspath\" -dvd-video -no-pad -V \"$::burn::id\" -p PgcEdit -m \\*backup\\* -m \\*Backup\\* -m .DS_Store -m \"Copy of \\*\" \"$in\"\n"
			}
			saveFile $bat auto $cmd
			if {$::tcl_platform(platform) != "windows"} {
				file attributes $bat -permissions +x 
			}
			if {[catch {set fh [open "|\"$bat\"" r]} errstr]} {
				tk_messageBox -title "PgcEdit: Burn DVD" -icon error \
						-message $errstr -parent $w -type ok 
				set error true
			} else {
				fconfigure $fh -translation binary
				set dvdvideostart -1
				set sec 0
				while {![eof $fh]} {
					set buf [read $fh 2048]
					if {[string length $buf] != 2048} break
					if {[string range $buf 0 11] == "DVDVIDEO-VMG"} {
						set dvdvideostart $sec
						break
					}
					incr sec
				}
				set pid [pid $fh]
				if {$::tcl_platform(platform) == "windows"} {
					catch {exec -- [file join $::config(bindir) pskill.exe] $pid}
				} else {
					catch {exec -- kill -9 $pid}
				}
				catch {close $fh}
				if {$dvdvideostart == -1} {
					set error true
					tk_messageBox -title "PgcEdit: Burn DL DVD" -icon error -parent $w -type ok \
							-message "Error: Cannot find the first VMG sector."
				}
			}
			if {! $error} {
				# Find first and last sector of each VTS, and compute total size of all VTSs
				set videosectorsize 0
				for {set vts 0} {$vts <= $::pgcs(numvts)} {incr vts} {
					set vts_start($vts) [expr $dvdvideostart + $videosectorsize]
					incr videosectorsize [::writedvd::all_sectors_used $::dvddir $vts]
					set vts_last($vts) [expr $dvdvideostart + $videosectorsize - 1]
				}
				set dvdromsecs [lindex $dvdromsizelist 0]
				
				# Compute total ISO size, and valid range for layer break
				set ::burn::compilsize [expr $dvdvideostart+$videosectorsize+$dvdromsecs+1]
				set ::burn::lb_opt [expr $::burn::compilsize / 2]
				set ::burn::lb_max [expr $::burn::dldisksize / 2]
				set ::burn::lb_min [expr (($::burn::compilsize - $::burn::lb_max + 15) / 16) * 16]

				# Find domains suitables for the layer break
				set voboklist {}
				for {set vts 0} {$vts <= $::pgcs(numvts)} {incr vts} {
					# if domain is entierly before the LB range, skip it
					if {$vts == 0 || $vts_last($vts) < $::burn::lb_min} continue
					# if domain is entierly after the LB range, leave loop
					if {$vts_start($vts) > $::burn::lb_max} break

					# compute length of VOBs
					set vobfilename [file join $::dvddir VTS_[format %02i $vts]_0.VOB]
					if {[file exists $vobfilename]} {
						set menuvobsize [expr {[file size $vobfilename]/2048}]
					} else {
						set menuvobsize 0
					}
					set titlevobsize 0
					for {set i 1} {$i < 10} {incr i} {
						set vobfilename [file join $::dvddir VTS_[format %02i $vts]_$i.VOB]
						if {[file exists $vobfilename]} {
							incr titlevobsize [expr [file size $vobfilename] / 2048]
						}
					}

					# compute start of menu VOB
					set ifosize [expr {[file size [file join $::dvddir VTS_[format %02i $vts]_0.IFO]] / 0X800}]
					set menuvobstart [expr {$vts_start($vts) + $ifosize}]
					# if menu VOB start is after LB range, leave loop
					if {$menuvobstart > $::burn::lb_max} break

					# compute end of menu VOB, and keep VOB in list if it ends after start of LB range
					set menuvobend [expr {$menuvobstart + $menuvobsize - 1}]
					if {$menuvobsize > 0 && $menuvobend > $::burn::lb_min} {
						lappend voboklist [list $vts menu $menuvobstart $menuvobend]
					}

					# compute start of title VOBs
					set titlevobstart [expr $menuvobend+1]
					# if start of title VOB is after LB range, leave loop
					if {$titlevobstart > $::burn::lb_max} break

					# compute end of title VOBs
					set titlevobend [expr {$menuvobend + $titlevobsize}]
					lappend voboklist [list $vts pgc $titlevobstart $titlevobend]
				}
				if {$::config(debug) > 0} {
					puts "\nDVD-9 Layer Break cells calculation:"
					puts "Header: $dvdvideostart sectors (start at sector # 0 : 0x[format %08X 0])"
					puts "DVD-Video files: $videosectorsize sectors (start at sector # $dvdvideostart : 0x[format %08X [expr $dvdvideostart * 2048]])"
					puts "DVD-ROM files: $dvdromsecs sectors (start at sector # [expr $dvdvideostart+$videosectorsize] : 0x[format %08X [expr ($dvdvideostart+$videosectorsize)*2048]])"
					puts "Footer: Always 1 sector (start at sector # [expr $dvdvideostart+$videosectorsize+$dvdromsecs] : 0x[format %08X [expr ($dvdvideostart+$videosectorsize+$dvdromsecs)*2048]])"
					puts "Total ISO size: $::burn::compilsize sectors ([expr $::burn::compilsize * 2048] bytes : 0x[format %08X [expr $::burn::compilsize * 2048]])"
					puts "\nLayer break must be between sector $::burn::lb_min and sector $::burn::lb_max"
					puts "VOBs with possible layer break:"
					puts "VTS # domain: startsec (address) -> endsec (address)"
					foreach domainlist $voboklist {
						puts "VTS [lindex $domainlist 0] [lindex $domainlist 1]: [lindex $domainlist 2] (0x[format %08X [expr [lindex $domainlist 2]*2048]]) -> [lindex $domainlist 3] (0x[format %08X [expr [lindex $domainlist 3]*2048]])"
					}
				}
				if {$voboklist == ""} {
					tk_messageBox -title "PgcEdit: Burn DL DVD" -icon error -parent $w -type ok \
							-message "Can't find a suitable cell for the layer break!"
					set error true
				} else {
					# build cells list with cells compatibles with the layer break
					set cellslist ""
					foreach domainlist $voboklist {
						set vts      [lindex $domainlist 0]
						set domain   [lindex $domainlist 1]
						set vobstart [lindex $domainlist 2]
						if {$domain == "menu"} {
							for {set lu 1} {$lu <= $::menus($vts,numlus)} {incr lu} {
								for {set pgc 1} {$pgc <= $::menus($vts,$lu,numpgcs)} {incr pgc} {
									set cellpbtable $::menus($vts,$lu,$pgc,cellpbtable)
									set cellpostable $::menus($vts,$lu,$pgc,cellpostable)
									for {set cell 1} {$cell <= $::menus($vts,$lu,$pgc,numcells)} {incr cell} {
										set idx [expr {($cell-1)*24}]
										set cellstart [get_int cellpbtable [expr {$idx+8}] 4]
										set isocellstart [expr $cellstart+$vobstart]
										if {$isocellstart < $::burn::lb_min || $isocellstart > $::burn::lb_max} continue
										set cellend [get_int cellpbtable [expr {$idx+20}] 4]
										set seamless [expr {([get_int cellpbtable $idx 1] & 8) / 8}]
										set celltime [::pgced::BCDtime [string range $cellpbtable [expr {$idx+4}] [expr {$idx+7}]] false]
										set posidx [expr {($cell-1)*4}]
										set vid [get_int cellpostable [expr $posidx] 2]
										set cid [get_int cellpostable [expr {$posidx+3}] 1]
										set angletype [expr {[get_int cellpbtable $idx 1] & 244}]
										if {$angletype == 0} {
											lappend cellslist [list "0x[format %08X $isocellstart]" menu $vts $lu $pgc $vobstart $cell $cellstart $cellend $seamless $celltime $vid $cid]
										}
									}
								}
							}
						} else {
							for {set pgc 1} {$pgc <= $::pgcs($vts,numpgcs)} {incr pgc} {
								set cellpbtable $::pgcs($vts,$pgc,cellpbtable)
								set cellpostable $::pgcs($vts,$pgc,cellpostable)
								for {set cell 1} {$cell <= $::pgcs($vts,$pgc,numcells)} {incr cell} {
									set idx [expr {($cell-1)*24}]
									set cellstart [get_int cellpbtable [expr {$idx+8}] 4]
									set isocellstart [expr $cellstart+$vobstart]
									if {$isocellstart < $::burn::lb_min || $isocellstart > $::burn::lb_max} continue
									set cellend [get_int cellpbtable [expr {$idx+20}] 4]
									set seamless [expr {([get_int cellpbtable $idx 1] & 8) / 8}]
									set celltime [::pgced::BCDtime [string range $cellpbtable [expr {$idx+4}] [expr {$idx+7}]] false]
									set posidx [expr {($cell-1)*4}]
									set vid [get_int cellpostable [expr $posidx] 2]
									set cid [get_int cellpostable [expr {$posidx+3}] 1]
									set angletype [expr {[get_int cellpbtable $idx 1] & 244}]
									if {$angletype == 0} {
										lappend cellslist [list "0x[format %08X $isocellstart]" pgc $vts -1 $pgc $vobstart $cell $cellstart $cellend $seamless $celltime $vid $cid]
									}
								}
							}
						}
					}
					# sort cells list by absolute starting sector
					set ::burn::dl_cellslist [lsort $cellslist]
					if {$::burn::dl_cellslist == ""} {
						tk_messageBox -title "PgcEdit: Burn DL DVD" -icon error -parent $w -type ok \
								-message "Can't find a suitable cell for the layer break!"
						set error true
					} else {
						# GUI: ask the user where he wants to put the layer break
						set w2 ".burndl"
						if {[winfo exists $w2]} {
							destroy $w2
						}
						toplevel $w2 -class Dialog
						wm withdraw $w2
						wm protocol $w2 WM_DELETE_WINDOW {set ::burn::burndl_done 0}
						bind $w2 <Escape> "set ::burn::burndl_done 0"
						if {$::config(tk) != "aqua"} {wm transient $w2 .}
						if {$::tcl_platform(platform) == "windows"} {catch {wm attributes $w2 -toolwindow 1}}
						wm title $w2 "Burn Double Layer DVD:  Select Layer Break"
	
						# infos
						frame  $w2.f -borderwidth 2 -relief groove -padx 4 -pady 4
						pack   $w2.f -padx 4 -pady 4 -fill x
						label  $w2.f.l00 -text "Total number of sectors in compilation"
						entry  $w2.f.e01 -textvariable ::burn::compilsize -state readonly \
								-disabledforeground black -width 7 -justify right
						label  $w2.f.l02 -text "of maximum"
						entry  $w2.f.e03 -textvariable ::burn::dldisksize -state readonly \
								-disabledforeground black -width 7 -justify right
						label  $w2.f.l04 -text "  Optimal LB position for small disc size around"
						entry  $w2.f.e05 -textvariable ::burn::lb_opt -state readonly \
								-disabledforeground black -width 7 -justify right
	
						frame  $w2.f.pad1 -bd 1
	
						label  $w2.f.l10 -text "The Layer Break must be between original sector"
						entry  $w2.f.e11 -textvariable ::burn::lb_min -state readonly -disabledforeground black -width 7 -justify right
						label  $w2.f.l12 -text "and sector"
						entry  $w2.f.e13 -textvariable ::burn::lb_max -state readonly \
								-disabledforeground black -width 7 -justify right
						label  $w2.f.l14 -text "  DL DVD-R L0 data capacity"
						entry  $w2.f.e15 -textvariable ::burn::force_lb_display -state readonly \
								-disabledforeground black -width 7 -justify right
						if {$::burn::media == "Dual layer DVD-R"} {
							set ::burn::force_lb_display $::burn::layer_break_sector
							set ::burn::force_lb $::burn::layer_break_sector
						} else {
							set ::burn::force_lb_display "0 (N/A)"
							set ::burn::force_lb 0
						}
	
						frame  $w2.f.pad2 -bd 1
	
						if {$::burn::force_lb > 0} {
							label  $w2.f.l20 -text "Sectors in L0"
						} else {
							label  $w2.f.l20 -text "Final position of layer break = Sectors in L0"
						}
						entry  $w2.f.e21 -textvariable ::burn::l0sectors -state readonly -disabledforeground black -width 7 -justify right
						label  $w2.f.l22 -text "Offset in L0"
						entry  $w2.f.e23 -textvariable ::burn::absoffset -state readonly \
								-disabledforeground black -width 7 -justify right
						label  $w2.f.l24 -text "  Offset really used for DL DVD-R"
						entry  $w2.f.e25 -textvariable ::burn::true_absoffset -state readonly \
								-disabledforeground black -width 7 -justify right
	
						frame  $w2.f.pad3 -bd 1
	
						label  $w2.f.l30 -text "Sectors in L1"
						entry  $w2.f.e31 -textvariable ::burn::l1sectors -state readonly \
								-disabledforeground black -width 7 -justify right
						label  $w2.f.l32 -text "ISO file size"
						entry  $w2.f.e33 -textvariable ::burn::isosize -state readonly \
								-disabledforeground black -width 7 -justify right

						if {$::burn::force_lb > 0} {
							label  $w2.f.l34 -text "Real position of layer break on DL DVD-R"
							label  $w2.f.e35 -text [expr $::burn::force_lb_display+1] \
									-bd 2 -relief sunken -width 7 -justify right
						}

						grid   $w2.f.l00 -row 0 -column 0 -sticky e
						grid   $w2.f.e01 -row 0 -column 1 -sticky ew
						grid   $w2.f.l02 -row 0 -column 2 -sticky e
						grid   $w2.f.e03 -row 0 -column 3 -sticky ew
						grid   $w2.f.l04 -row 0 -column 4 -sticky e
						grid   $w2.f.e05 -row 0 -column 5 -sticky ew
						grid   $w2.f.pad1 -row 1 -column 0 -ipady 1

						grid   $w2.f.l10 -row 2 -column 0 -sticky e
						grid   $w2.f.e11 -row 2 -column 1 -sticky ew
						grid   $w2.f.l12 -row 2 -column 2 -sticky e
						grid   $w2.f.e13 -row 2 -column 3 -sticky ew
						grid   $w2.f.l14 -row 2 -column 4 -sticky e
						grid   $w2.f.e15 -row 2 -column 5 -sticky ew
						grid   $w2.f.pad2 -row 3 -column 0 -ipady 2

						grid   $w2.f.l20 -row 4 -column 0 -sticky e
						grid   $w2.f.e21 -row 4 -column 1 -sticky ew
						grid   $w2.f.l22 -row 4 -column 2 -sticky e
						grid   $w2.f.e23 -row 4 -column 3 -sticky ew
						if {$::burn::force_lb > 0} {
							grid   $w2.f.l24 -row 4 -column 4 -sticky e
							grid   $w2.f.e25 -row 4 -column 5 -sticky ew
						}
						grid   $w2.f.pad3 -row 5 -column 0 -ipady 1

						grid   $w2.f.l30 -row 6 -column 0 -sticky e
						grid   $w2.f.e31 -row 6 -column 1 -sticky ew
						grid   $w2.f.l32 -row 6 -column 2 -sticky e
						grid   $w2.f.e33 -row 6 -column 3 -sticky ew
						if {$::burn::force_lb > 0} {
							grid   $w2.f.l34 -row 6 -column 4 -sticky e
							grid   $w2.f.e35 -row 6 -column 5 -sticky ew
						}
	
						# cells list
						frame  $w2.mf -borderwidth 2 -relief groove
						pack   $w2.mf -padx 4 -expand 1 -fill both
						listbox $w2.mf.c -yscrollcommand "$w2.mf.vs set" -height 10 -width 97 \
								-listvariable ::burn::cells_list -font $::config(fixed_width_font)
						pack   $w2.mf.c -side left -expand 1 -fill both
						if {$::config(use_preview)} {
							bind   $w2.mf.c <Double-1> "::burn::preview_cell $w2.mf.c cell"
						}
						bind   $w2.mf.c <ButtonRelease-1> "::burn::compute_dloffset $w2.mf.c"
						scrollbar $w2.mf.vs -command "$w2.mf.c yview" -orient vert
						pack   $w2.mf.vs -side left -fill y
	
						frame  $w2.lf -borderwidth 2 -relief groove
						pack   $w2.lf -padx 4 -pady 4 -fill x
						frame  $w2.lf.f
						pack   $w2.lf.f
						set txt "The layer break will be placed just before the selected cell."
						set txt "$txt\nWhenever possible, select Cell 1 of any PGC (a green line).  You will not notice the layer break."
						set txt "$txt\nBlue lines are also good Layer Break candidates, as they are already flagged as non-seamless."
						set txt "$txt\nA change in VOB ID (yellow lines) could also indicate the position of the original layer break."
						set txt "$txt\nIn case of reused cells, all cells sharing the same sector number (noted ' ' ) should be coloured if possible."
						set txt "$txt\n\nWhen you press OK, the selected cell will be flagged as non-seamless,"
						set txt "$txt the DVD will be saved, and the ISO creation process will begin."
						label  $w2.lf.f.lab -text $txt -justify left
						pack   $w2.lf.f.lab -padx 10 -anchor w
						if {$::tcl_platform(platform) == "windows"} {
							label  $w2.lf.f.lab2 -foreground red -text \
									"You MUST burn the ISO with ImgBurn, or the layer break position will be wrong!"
						} else {
							label  $w2.lf.f.lab2 -foreground red -text \
									"You MUST burn the ISO with a burning software that honor the layer break position and the gaps between IFO and BUPs!"
						}
						pack   $w2.lf.f.lab2 -padx 10 -anchor w
	
						# buttons
						frame  $w2.fb
						pack   $w2.fb -padx 2 -pady 4 -fill x
						if {$::config(use_preview)} {
							button $w2.fb.c1 -text "Preview cell"  -width 13 -command "::burn::preview_cell $w2.mf.c cell"
							pack   $w2.fb.c1 -side left -padx 2
							button $w2.fb.c2 -text "Preview PGC"   -width 13 -command "::burn::preview_cell $w2.mf.c pgc"
							pack   $w2.fb.c2 -side left -padx 3
						}
						button $w2.fb.c3 -text "Seamless cell" -width 13 -command "::burn::clear_layer_break $w2.mf.c"
						pack   $w2.fb.c3 -side left -padx 2
						::balloon::set_balloon $w2.fb.c3 "Set seamless flag (remove old\nLayer Break) on current cell.\nYou must select a blue line.\n(You don't need to press OK\nfor the change to take effect!)"
						frame  $w2.fb.pad
						pack   $w2.fb.pad -expand 1 -fill x -side left
						button $w2.fb.ok -text "OK" -width 13 -command {set ::burn::burndl_done 1}
						pack   $w2.fb.ok -side left -padx 3
						button $w2.fb.cancel -text "Cancel" -width 13 -command {set ::burn::burndl_done 0}
						pack   $w2.fb.cancel -side left -padx 2
						if {$::config(platform) == "mac"} {
							pack [frame $w2.fb.macpad] -side left -padx 6
						}
	
						# build contents of listbox, and set colored lines
						set ::burn::cells_list {}
						set item 0
						set sel_1 -1
						set sel_lb -1
						set sel_opt -1
						set sel_vid -1
						set lastlb -1
						set lastvid -1
						set vid_lba -1
						set lastdiff 9999999
						foreach c $::burn::dl_cellslist {
							set newlb [expr [lindex $c 5]+[lindex $c 7]]
	
							if {[lindex $c 1] == "menu"} {
								set txt [::main::pgc_label $::config(fixed_width_font) menu [lindex $c 2] [lindex $c 3] [lindex $c 4] -nocomment]
							} else {
								set txt [::main::pgc_label $::config(fixed_width_font) pgc  [lindex $c 2] [lindex $c 4] -nocomment]
							}
							while {[string length $txt] < 52} {set txt "$txt "}
							if {$newlb == $lastlb} {
								set txt "   ''  : ${txt}"
							} else {
								set txt "[format %7d $newlb]: ${txt}"
							}
							set txt "${txt}Cell[format %4d [lindex $c 6]] ([lindex $c 10]), V/CID: [lindex $c 11]/[lindex $c 12]"
							lappend ::burn::cells_list $txt
	
							set diff [expr abs($::burn::lb_opt - $newlb)]
							if {$diff < $lastdiff} {
								set sel_opt $item
								set lastdiff $diff
							}
							if {[lindex $c 11] != $lastvid && $lastvid != -1} {
								if {$sel_vid == -1} {
									set sel_vid $item
								} else {
									set sel_vid -2
								}
								set vid_lba $newlb
							}
							if {$vid_lba == $newlb} {
								$w2.mf.c itemconfigure $item -background #FFFF80	;# lightYellow
							}
							if {[lindex $c 9] == 0} {
								$w2.mf.c itemconfigure $item -background lightBlue
								if {$sel_lb == -1} {
									set sel_lb $item
								}
							}
							if {[lindex $c 6] == 1} {
								$w2.mf.c itemconfigure $item -background green
								if {$sel_1 == -1} {
									set sel_1 $item
								}
							}
	
							set lastlb $newlb
							set lastvid [lindex $c 11]
							incr item
						}
						
						# find best choice for layer break
						set item 0
						set oklist {}
						set wholelist {}
						foreach c $::burn::dl_cellslist {
							set lba [expr [lindex $c 5]+[lindex $c 7]]
							set color [$w2.mf.c itemcget $item -background]
							set old [lsearch $oklist $lba]
							if {$color != ""} {
								if {$old < 0 && [lsearch $wholelist $lba] < 0} {
									lappend oklist $lba
								}
							} else {
								if {$old >= 0} {
									lreplace $oklist $old $old
								}
							}
							lappend wholelist $lba
							incr item
						}
						if {[llength $oklist] > 0} {
							set lba [lindex $oklist 0]
							set item 0
							foreach c $::burn::dl_cellslist {
								if {[expr [lindex $c 5]+[lindex $c 7]] == $lba} {
									set selected $item
									break
								}
								incr item
							}
						} elseif {$sel_1 > -1} {
							set selected $sel_1
						} elseif {$sel_lb > -1} {
							set selected $sel_lb
						} elseif {$sel_vid > 0} {
							set selected $sel_vid
						} else {
							set selected $sel_opt
						}
						$w2.mf.c selection clear 0 end
						$w2.mf.c selection set $selected
						$w2.mf.c activate $selected
						catch {$w2.mf.c see [expr $selected -4]}
						compute_dloffset $w2.mf.c
	
						# window geometry
						$w2.mf.c configure -height 3 -width 97
						update
						wm minsize $w2 [winfo reqwidth $w2] [winfo reqheight $w2]
						set h [llength $::burn::cells_list]
						if {$h > 20} {set h 20}
						if {$h < 9} {set h 9}
						$w2.mf.c configure -height $h -width 100
						update
						set ww [winfo reqwidth $w2]
						set wh [winfo reqheight $w2]
						set wx [expr {[winfo rootx $w]+(([winfo width  $w]-$ww)/2)}]
						set wy [expr {[winfo rooty $w]+(([winfo height $w]-$wh)/2)-25}]
						if {$wx < 9} {set wx 9}
						if {$wy < 22} {set wy 22}
						$w2.mf.c configure -height 3 -width 97
						wm geometry $w2 ${ww}x$wh+$wx+$wy
						wm resizable $w2 1 1
	
						wm deiconify $w2
						focus $w2
						grab set $w2
	
						set ::burn::burndl_done -1
						tkwait variable ::burn::burndl_done
						set ci [lindex $::burn::dl_cellslist [$w2.mf.c curselection]]
						destroy $w2
						grab set $w
	
						if {! $::burn::burndl_done} {
							set error true
							set txt "Layer Break not set!"
							set ::burn::status $txt
							show_msg "Burn DVD: $txt"
						}
					}

					# End of GUI
					
					# check for free space on disk
					if {! $error} {
						set sectorsfree [get_free_disk_space $realout]
						if {$sectorsfree < $::burn::isosize && $sectorsfree != -1} {
							set r [tk_messageBox -title "PgcEdit: Burn DVD" -icon warning \
								-message "WARNING: Not enough free space left on hard disk!\n\nContinue anyway?" \
								-parent $w -type yesno -default no]
							if {$r == "no"} {
								set error true
							}
						}
					}

					# Compute absolute LB sector for ImgBurn
					if {! $error} {
						set txt "Layer Break set to sector $::burn::l0sectors."
						set ::burn::status $txt
						show_msg "Burn DVD: $txt"

						# interface with user: output layer break sector number, if needed
						$w.l0s configure -text "Layer Break (Sectors in L0):  $::burn::l0sectors"
						set txt "Layer Break position (needed for DVD Decrypter only!)\n\nNumber of sectors in first layer (L0): $::burn::l0sectors"
						set txt2 "go to \"Tool -> Settings\", \"ISO Write Mode\" tab."
						set txt2 "$txt2\nUnder \"Layer Break\", select \"User Specified\", and type (or paste) \"$::burn::l0sectors\""
						set txt2 "$txt2\n(without the quotes) in the \"Sectors in L0\" field.  Accept and burn the DVD."
						set txt2 "$txt2\nNote that this step is needed only if you burn with DVD Decrypter."
						
						if {$::burn::burn} {
							# sets LB sector in registry and clipboard for DVD Decrypter.
							if {[string first "DECRYPTER" [string toupper [file tail $::burn::imgburnpath]]] >= 0} {
								# Burn ISO immediately
								if {[info exists ::freewrap::progname]} {
									# Write DL value in registry for DVD Decrypter
									set regerr true
									if {! [catch {registry set "HKEY_CURRENT_USER\\Software\\DVD Decrypter" "ISOWRITE_LayerBreakSectors" $::burn::l0sectors dword}]} {
										if {! [catch {registry set "HKEY_CURRENT_USER\\Software\\DVD Decrypter" "ISOWRITE_LayerBreakMethod" 1 dword}]} {
											set regerr false
											set txt "$txt\n\nThe Layer Break value of DVD Decrypter's ISO Write Settings has been"
											set txt "$txt\nset automatically to this value in the registry."
										}
									}
									if {$regerr} {
										set ::burn::start ""	;# disable DVD Decrypter's burn autostart
										set txt "$txt\n\nCannot set automatically the DVD Decrypter ISO Write Settings!"
										set txt "$txt\n\nWhen DVD Decrypter starts, $txt2"
									}
								} else {
									# Cannot access registry without freeWrap
									set ::burn::start ""	;# disable DVD Decrypter's burn autostart
									set txt "$txt\n\nWhen DVD Decrypter starts, $txt2"
								}
							}
						} else {
							# Burn ISO later
							set txt "$txt\n\nIf you burn later with DVD Decrypter, remember this number!"
							set txt "$txt\nTo burn the ISO, load it and $txt2"
							set regerr true
						}
						set txt "$txt\n\nDo you want to copy \"$::burn::l0sectors\" to the clipboard ?"
						set txt "$txt\n(Do not close PgcEdit before pasting, or the clipboard will be emptied.)"
						if {$::tcl_platform(platform) != "windows"} {
							set txt "Layer Break position (needed for DVD Decrypter only!)\n\nNumber of sectors in first layer (L0): $::burn::l0sectors"
							set txt "$txt\n\nDo you want to copy \"$::burn::l0sectors\" to the clipboard ?"
						}
						if {$::burn::force_lb == 0 && [string first "DECRYPTER" \
								[string toupper [file tail $::burn::imgburnpath]]] >= 0} {
							set r [tk_messageBox -title "PgcEdit Burn DL-DVD" -message $txt -type yesnocancel -default yes -icon question -parent $w]
						} else {
							set r "no"
						}
						if {$r == "yes"} {
							clipboard clear
							clipboard append $::burn::l0sectors
						} elseif {$r == "cancel"} {
							set error true
						}
					}
					
					# LB is known now.  Modify the DVD files
					if {!$error} {
						# disable seamless flag on selected cell (and on reused cells, if any)
						set txt "Modifying IFOs..."
						set ::burn::status $txt
						show_msg "Burn DVD: $txt"
						set lbcellstxt ""
						set item 0
						foreach cc $::burn::dl_cellslist {
							if {	[lindex $cc 7] == [lindex $ci 7] && \
									[lindex $cc 1] == [lindex $ci 1] && \
									[lindex $cc 2] == [lindex $ci 2]} {

								set lbcellstxt "${lbcellstxt}[lindex $::burn::cells_list $item]\n"
								if {[lindex $cc 1] == "menu"} {
									set cellpbtable $::menus([lindex $cc 2],[lindex $cc 3],[lindex $cc 4],cellpbtable)
								} else {
									set cellpbtable $::pgcs([lindex $cc 2],[lindex $cc 4],cellpbtable)
								}
								set cell [lindex $cc 6]
								set idx [expr {($cell-1)*24}]
								set_int cellpbtable $idx [expr {[get_int cellpbtable $idx 1] & 0xF7}] 1
								if {[lindex $cc 1] == "menu"} {
									set ::menus([lindex $cc 2],[lindex $cc 3],[lindex $cc 4],cellpbtable) $cellpbtable
								} else {
									set ::pgcs([lindex $cc 2],[lindex $cc 4],cellpbtable) $cellpbtable
								}
							}
							incr item
						}
						set txt "Saving the DVD..."
						set ::burn::status $txt
						show_msg "Burn DVD: $txt"
						unset -nocomplain ::writedvd::dloffset
						set ::writedvd::dloffset $::burn::true_absoffset
						if {[::writedvd::writedvd $::dvddir] > 0} {
							set error true
						} else {
							::main::dvd_modified false false
							set txt "Ready to burn..."
							set ::burn::status $txt
							show_msg "Burn DVD: $txt"
						}
						unset -nocomplain ::writedvd::dloffset
					}
				}
			}
		}	;### End of DL stuff.

		# Delete already existing ISO image
		if {!$error} {
			if {$::burn::splitoutput != ""} {
				for {set i 0} {$i < 100} {incr i} {
					set fname $out[format _%02d $i]
					if {[file exists $fname]} {
						catch {file delete $fname}
					} else {
						break
					}
				}
			}
			catch {file delete $realout}
		}

		# Launch Make ISO batch command
		if {!$error} {
			set txt "Generating ISO image.  Please wait..."
			set ::burn::status $txt
			show_msg "Burn DVD: $txt"

			set ::burn::processing true

			catch {file delete $log}
			set bat [file normalize [file join $::config(tempdir) "MakeISO.bat"]]
			if {$::tcl_platform(platform) == "windows"} {
				set cmd "@echo off\n"
				set cmd "${cmd}\"$::burn::mkisofspath\" -dvd-video -no-pad -V \"$::burn::id\" -o \"$out\" -p PgcEdit -m *backup* -m *Backup* -m .DS_Store -m \"Copy of *\" $::burn::splitoutput \"$in\" 2>&1\n"
				set cmd "${cmd}if errorlevel 1 echo $mkisofserror\n"
			} else {
				set cmd "#!/bin/sh\n"
				set cmd "${cmd}\"$::burn::mkisofspath\" -dvd-video -no-pad -V \"$::burn::id\" -o \"$out\" -p PgcEdit -m \\*backup\\* -m \\*Backup\\* -m .DS_Store -m \"Copy of \\*\" $::burn::splitoutput \"$in\" 2>&1\n"
				set cmd "${cmd}rc=\$?\n"
				set cmd "${cmd}if test \$rc -gt 0; then echo \"$mkisofserror\"; fi\n"
			}
			if {[saveFile $bat auto $cmd] > 0} {
				set error true
			}
		}
		if {!$error} {
			if {$::tcl_platform(platform) != "windows"} {
				file attributes $bat -permissions +x 
			}
			if {[info exists fh]} {catch {close $fh}}
			if {[catch {set fh [open "|\"$bat\"" r]} errstr]} {
				tk_messageBox -title "PgcEdit: Burn DVD" -icon error \
						-message $errstr -parent $w -type ok 
				set error true
			} else {
				$w.fb.cancel configure -text "Abort" -state normal -command {
							set ::burn::burn_done 0
							set ::burn::status "Aborting..."
							show_msg "Burn DVD: Aborting..."
							set ::burn::pause false
							update idletasks
							after 100 {set ::burn::pause true}
							tkwait variable ::burn::pause
						}
				wm protocol $w WM_DELETE_WINDOW {
							set ::burn::burn_done 0
							set ::burn::status "Aborting..."
							show_msg "Burn DVD: Aborting..."
							set ::burn::pause false
							update idletasks
							after 100 {set ::burn::pause true}
							tkwait variable ::burn::pause
						}
			}
		}

		# parse mkisofs output while it is running, and check for Abort
		set showlogout false
		set warnings false
		if {!$error} {
			set showlogout true
			set logout [log_header $in $mkisofsversionstring]
			if {$::burn::absoffset > 0} {
				set logout "${logout}Layer break is at absolute sector $::burn::l0sectors.  (Offset in L0 is $::burn::absoffset.)"
				set logout "$logout\nLayer break cell:\n$lbcellstxt\n"
			}
			set pc 0
			while {![eof $fh]} {
				# parse mkisofs output
				set line [gets $fh]
				if {[string first "% done, estimate finish" $line] >= 0} {
					set pc [string trim [string range $line 0 [string first "%" $line]] " %"]
					set ::burn::status "Generating ISO image: [string range $line 0 [string last " " $line]]"
					update_progresbar $w.c $pc
				} else {
					if {[string first "/cygdrive/" $line] != -1} {
						set warnings true
						set line [string trim [string map {"/cygdrive/" "\n/cygdrive/"} $line] \n]
						set idx1 [string first "/cygdrive/" $line]
						while {$idx1 >= 0} {
							set idx2 [string first "/mkisofs:" $line $idx1]
							incr idx2
							incr idx1 -1
							set line [string range $line 0 $idx1][string range $line $idx2 end]
							set idx1 [string first "/cygdrive/" $line]
						}
					}
					if {[string first "Unable" $line] != -1} {
						set warnings true
					}
					if {[string first "Can't" $line] != -1} {
						set warnings true
					}
					if {[string first "extents written" $line] >= 0} {
						set ::burn::status "Done."
						set pc 100
						update_progresbar $w.c 100
					}
					if {[string first "$mkisofserror" $line] >= 0} {
						set ::burn::status "$mkisofserror"
						set error true
					}
					set logout "${logout}$line\n"
					if {[string first "The pad was" $line]>-1} {
						if {[string first "for file VIDEO_TS.IFO" $line]==-1} {
							set line ""
						} else {
							if {[lindex $line 3] > 15} {
								set line "Generating ISO image: Writing [lindex $line 3] L0 padding sectors in VMG..."
							} else {
								set line ""
							}
						}
					}
					if {$line != ""} {
						set ::burn::status "$line"
					}
				}

				# allow screen refresh, and check if we need to abort
				set ::burn::pause false
				update idletasks
				after 15 {set ::burn::pause true}
				tkwait variable ::burn::pause
				if {$::burn::burn_done == 0} {
					set pid [pid $fh]
					catch {close $fh}
					if {$::tcl_platform(platform) == "windows"} {
						catch {exec -- [file join $::config(bindir) pskill.exe] $pid}
					} else {
						catch {exec -- kill -9 $pid}
					}
					file delete $::burn::out
					set error true
					set logout "$logout\nAborted by user.\n"
					set ::burn::status "Aborted."
					show_msg "Burn DVD: Aborted."
					break
				}
			}
			if {$pc != 100} {
				set warnings true
			}
		}

		# close mkisofs output
		if {!$error} {
			set err [catch {close $fh} errstr]
			if {$err} {
				set logout "$logout\n$errstr\n"
				set error true
			} else {
				set logout "${logout}ISO created"
				if {$warnings} {
					set logout "${logout}, WITH WARNINGS!\n"
				} else {
					set logout "${logout} OK.\n"
				}
			}
		}

		# create the .LST file if option to split output is ON
		if {!$error && $::burn::splitoutput != ""} {
			set txt "IMAGELIST\n"
			for {set i 0} {$i < 100} {incr i} {
				set fname $out[format _%02d $i]
				if {[file exists $fname]} {
					set txt "${txt}$fname\n"
				} else {
					break
				}
			}
			saveFile $realout auto $txt
		}

		# delete ISO image in case of error
		if {$error && $::burn::processing} {
			if {$::burn::splitoutput != ""} {
				for {set i 0} {$i < 100} {incr i} {
					set fname $out[format _%02d $i]
					if {[file exists $fname]} {
						catch {file delete $fname}
					} else {
						break
					}
				}
			}
			catch {file delete $realout}
		}

		# show log if requested and in case of error
		if {$showlogout && $::burn::processing && ($::burn::showlog || $error || $warnings)} {
			if {$error} bell
			::main::showtext .burnlog "PgcEdit Burn DVD - ISO creation log" $logout -defaultfilename "[file rootname $out]_log.txt"
			after 500 {set ::burn::pause 1}
			tkwait variable ::burn::pause
		}
	}

	# mount image
	if {!$error && $::burn::mount && $::burn::splitoutput == ""} {
		set ::burn::status "ISO created OK!  Mounting ISO image..."
		show_msg "Burn DVD: ISO created OK! Mounting ISO image..."
		set cmd1 "\"$::burn::daemonpath\" -unmount $::burn::mount_device\n"
		set cmd2 "\"$::burn::daemonpath\" -mount $::burn::mount_device,\"$realout\"\n"
		set bat [file join $::config(tempdir) "MountISO.bat"]
		saveFile $bat auto $cmd1$cmd2
		if {[catch {exec -- $bat &} errstr]} {
			tk_messageBox -title "PgcEdit: Burn DVD" -icon error \
					-message "Daemon-Tools error:\n$errstr" \
					-parent $w -type ok
		} else {
			after 1000
			#catch {exec -- $::burn::daemonpath &}	;# show Daemon-Tools icon in tray
			if {$::burn::burn} {
				after 7000
			}
		}
	}

	# Burn using ImgBurn (or DVDD)
	if {!$::burn::burn} {
		bell
	}
	if {!$error && $::burn::burn} {
		set txt "ISO created OK!  Burning DVD..."
		set ::burn::status $txt
		show_msg "Burn DVD: $txt"
		update idletasks
		after 500 {set ::burn::pause 1}
		tkwait variable ::burn::pause
		if {[string first "DECRYPTER" [string toupper [file tail $::burn::imgburnpath]]] >= 0} {
			if {[catch {exec -- $::burn::imgburnpath /MODE ISOWRITE $::burn::start $::burn::eraserw /SPEED $::burn::speed /VERIFY $::burn::verify $::burn::close $::burn::shutdown /DELETEIMAGE $::burn::deleteimage /SRC "$realout" /dest $::burn::burnerletter &} errstr]} {
				tk_messageBox -title "PgcEdit: Burn DVD" -icon error \
						-message "DVD Decrypter error:\n$errstr" \
						-parent $w -type ok
				set error true
			}
		} else {
			if {$burndl} {
				if {[catch {exec -- $::burn::imgburnpath /MODE ISOWRITE $::burn::start $::burn::eraserw /LAYERBREAK $::burn::l0sectors /SPEED $::burn::speed /VERIFY $::burn::verify $::burn::close $::burn::shutdown /DELETEIMAGE $::burn::deleteimage /SRC "$realout" /dest $::burn::burnerletter &} errstr]} {
					tk_messageBox -title "PgcEdit: Burn DVD" -icon error \
							-message "ImgBurn error:\n$errstr" \
							-parent $w -type ok
					set error true
				}
			} else {
				if {[catch {exec -- $::burn::imgburnpath /MODE ISOWRITE $::burn::start $::burn::eraserw /SPEED $::burn::speed /VERIFY $::burn::verify $::burn::close $::burn::shutdown /DELETEIMAGE $::burn::deleteimage /SRC "$realout" /dest $::burn::burnerletter &} errstr]} {
					tk_messageBox -title "PgcEdit: Burn DVD" -icon error \
							-message "ImgBurn error:\n$errstr" \
							-parent $w -type ok
					set error true
				}
			}
		}
	}

	# if Shutdown option is ON, exit PgcEdit.
	if {!$error && $::burn::burn && $::burn::shutdown == "/SHUTDOWN"} {
		show_msg "Burn DVD: Exiting PgcEdit."
		if {$::config(save_setups_on_exit)} {
			save_user_prefs
		}
		exit
	}

	# quit burn
	trace remove variable ::burn::out write ::burn::validate_burn
	trace remove variable ::burn::id  write ::burn::validate_burn
	set ::burn::processing false
	destroy $w
}

proc validate_burn {args} {
	set w .burn
	if {!$::burn::processing} {
		set ::burn::status "Ready."
		bind $w <Return> {set ::burn::burn_done 1}
	}
	if {$::tcl_platform(platform) == "windows"} {
		if {![file isfile $::burn::imgburnpath] || $::burn::burnerletter == ""} {
			if {![file isfile $::burn::imgburnpath]} {
				set ::burn::status "Error in burn setup: ImgBurn.exe path not valid!"
			} else {
				set ::burn::status "Error in burn setup: DVD Burner drive letter not set!"
			}
			set ::burn::burn false
			$w.opts.burn configure -state disabled
			$w.fb.dd configure -state disabled
		} else {
			$w.opts.burn configure -state normal
			$w.fb.dd configure -state normal
		}
		if {$::burn::burn} {
			set state normal
			$w.opts.bo.sp.l configure -foreground [$w.fb.ok cget -foreground]
		} else {
			set state disabled
			$w.opts.bo.sp.l configure -foreground [$w.fb.ok cget -disabledforeground]
		}
		$w.opts.bo.sp.speed configure -state $state
		$w.opts.bo.eraserw  configure -state $state
		$w.opts.bo.verify   configure -state $state
		$w.opts.bo.start    configure -state $state
		$w.opts.bo.close    configure -state $state
		$w.opts.bo.shutdown configure -state $state
		$w.opts.bo.del      configure -state $state
	}

	if {![file isfile $::burn::mkisofspath] && $::tcl_platform(platform) == "windows"} {
		$w.fb.ok configure -state disabled
		bind $w <Return> {}
		set ::burn::status "Error in burn setup: mkisofs.exe path not valid!"
	} else {
		set extension [string toupper [file extension $::burn::out]]
		if {[file isdirectory [file dirname $::burn::out]] && \
				![file isdirectory $::burn::out] && \
				[string toupper [file tail $::burn::out]] != ".ISO" && \
				[file tail $::burn::out] != "" && \
				$extension == ".ISO" && \
				[string range $::burn::out end end] != "\\" && \
				[string range $::burn::out end end] != "/" && \
				$::burn::id != "" && ! $::burn::processing} {
			$w.fb.ok configure -state normal
			bind $w <Return> {set ::burn::burn_done 1}
		} else {
			if {![file isdirectory [file dirname $::burn::out]]} {
				set ::burn::status "Output ISO path not valid!"
			}
			if {$extension != ".ISO"} {
				set ::burn::status "Output ISO extension not valid!"
			}
			if {[file isdirectory $::burn::out] || \
					[string toupper [file tail $::burn::out]] == ".ISO" || \
					[file tail $::burn::out] == "" || \
					[string range $::burn::out end end] == "\\" || \
					[string range $::burn::out end end] == "/"} {
				set ::burn::status "Output ISO filename not valid!"
			}
			if {$::burn::id == ""} {
				set ::burn::status "Volume label empty!"
			}
			$w.fb.ok configure -state disabled
			bind $w <Return> {}
		}
	}
	
	if {$::tcl_platform(platform) == "windows"} {
		if {[file isfile $::burn::daemonpath]} {
			$w.fb.dt configure -state normal
		} else {
			$w.fb.dt configure -state disabled
		}
		if {![file isfile $::burn::daemonpath] || $::burn::splitoutput != ""} {
			set ::burn::mount false
			$w.opts.fmount.mount configure -state disabled
		} else {
			$w.opts.fmount.mount configure -state normal
		}
		if {$::burn::mount} {
			$w.opts.fmount.device configure -state normal
			$w.opts.fmount.lab configure -foreground [$w.opts.fmount.device cget -foreground]
		} else {
			$w.opts.fmount.device configure -state disabled
			$w.opts.fmount.lab configure -foreground [$w.opts.fmount.device cget -disabledforeground]
		}
	}
}


proc validate_id_entry {id} {
	if {$id==""} {
		return true
	}
	if {[string length $id]>32} {
		bell
		return false
	}
	if {[string is alnum $id]} {
		return true
	}
	for {set i 0} {$i < [string length $id]} {incr i} {
		set c [string range $id $i $i]
		if {[string first $c {/\\:~`*.;\"?<>#}] > -1} {
			bell
			return false
		}
	}
	return true
}

proc validate_publisher_entry {id} {
	if {[string length $id]>128} {
		bell
		return false
	}
	return true
}

# Compute absolute LB sector for ImgBurn
proc compute_dloffset {w} {
	set ci [lindex $::burn::dl_cellslist [$w curselection]]
	set origabsvobstart [lindex $ci 5]
	set origcellstart   [lindex $ci 7]
	set origabscellstart [expr $origabsvobstart+$origcellstart]

	if {$origabscellstart <= [expr $::burn::compilsize/2]} {
		set absoffset [expr $::burn::compilsize-($origabscellstart*2)]
		# ensure that L0 is greater than L1.  (not sure if it is really needed)
		if {$absoffset == 0} {set absoffset 1}
	} else {
		set absoffset 0
	}
	if {[expr ($origabscellstart+$absoffset)%16] > 0} {
		incr absoffset [expr 16-(($origabscellstart+$absoffset)%16)]
	}
	set ::burn::l0sectors [expr $origabscellstart+$absoffset]
	set ::burn::absoffset $absoffset
	set ::burn::isosize [expr $::burn::compilsize+$absoffset]
	set ::burn::l1sectors [expr $::burn::isosize-$::burn::l0sectors-1]
	if {$::burn::force_lb > 0} {
		set ::burn::true_absoffset [expr $::burn::force_lb - $::burn::l0sectors + $::burn::absoffset]
	} else {
		set ::burn::true_absoffset $::burn::absoffset
	}
	return $absoffset
}

# Clear layer break on selected cell
proc clear_layer_break {w} {
	set ci [lindex $::burn::dl_cellslist [$w curselection]]
	# ci list:	$hex_isocellstart=0 $type=1 $vts=2 $lu=3 $pgc=4 $vobstart=5 $cell=6
	# 			$cellstart=7 $cellend=8 $seamless=9 $celltime=10 $vid=11 $cid=12
	if {[lindex $ci 9]==1 || [lindex $ci 6]==1 || [lindex $ci 5]==0} {
		bell
		return
	}
	if {[lindex $ci 1] == "menu"} {
		set cellpbtable  $::menus([lindex $ci 2],[lindex $ci 3],[lindex $ci 4],cellpbtable)
		set cellpostable $::menus([lindex $ci 2],[lindex $ci 3],[lindex $ci 4],cellpostable)
	} else {
		set cellpbtable  $::pgcs([lindex $ci 2],[lindex $ci 4],cellpbtable)
		set cellpostable $::pgcs([lindex $ci 2],[lindex $ci 4],cellpostable)
	}
	set cell [lindex $ci 6]
	set idx [expr {($cell-1) * 24}]
	set vobu [get_int cellpbtable [expr $idx+8] 4]
	set last_vobu_end [get_int cellpbtable [expr $idx-4] 4]
	if {[expr {$last_vobu_end+1}]!=$vobu} {
		bell
		return
	}

	lset ci 9 1
	lset ::burn::dl_cellslist [$w curselection] $ci
	set_int cellpbtable $idx [expr {[get_int cellpbtable $idx 1] | 8}] 1
	if {[lindex $ci 1] == "menu"} {
		set ::menus([lindex $ci 2],[lindex $ci 3],[lindex $ci 4],cellpbtable) $cellpbtable
	} else {
		set ::pgcs([lindex $ci 2],[lindex $ci 4],cellpbtable) $cellpbtable
	}
	$w itemconfigure [$w curselection] -background {}

	set idx [expr {($cell-1) * 4}]
	set vid [get_int cellpostable $idx 2]
	set lastvid [get_int cellpostable [expr {$idx-4}] 2]
	if {$vid != $lastvid} {
		$w itemconfigure [$w curselection] -background #FFFF80	;# lightYellow
	}

	::main::dvd_modified true false
}

proc preview_cell {w mode} {
	set ci [lindex $::burn::dl_cellslist [$w curselection]]
	if {[lindex $ci 1] == "menu"} {
		set idx [lindex $ci 2],[lindex $ci 3],[lindex $ci 4]
	} else {
		set idx [lindex $ci 2],[lindex $ci 4]
	}
	if {$mode == "cell"} {
		::preview::preview2 [lindex $ci 1] $idx [lindex $ci 6] false false 0
	} else {
		::preview::preview2 [lindex $ci 1] $idx 0 false false 0
	}
}

proc log_header {inputdir mkisofsversionstring} {
	set data "mkisofs log for DVD \"$::burn::id\"\nFrom: \"$inputdir\"\n"
	set data "${data}DVD-TEXT General Name: \"[::utils::get_General_Name]\"\n"
	set data "${data}Provider ID: \"[::utils::get_provider_ID]\"\n"
	set data "${data}Number of VTS: $::pgcs(numvts)\n"
	set data "${data}Output file: \"$::burn::out\"\n"
	set data "${data}Volume label: \"$::burn::id\"\n\n"
	set data "${data}$mkisofsversionstring\n"
	return $data
}

proc readLog {logfile} {
	set errnum [catch {set in [open $logfile r]} err]
	if {$errnum} {
		errmsg $errnum "opening file for read" $err
		return
	}
	fconfigure $in -translation auto
	set warnings false
	set data ""
	while {! [eof $in]} {
		set errnum [catch {set line [gets $in]} err]
		if {$errnum} {
			errmsg $errnum "reading file" $err
		}
		if {[string first "% done, estimate finish" $line] == -1} {
			if {[string first "/cygdrive/" $line] != -1} {
				set warnings true
				set line [string trim [string map {"/cygdrive/" "\n/cygdrive/"} $line] \n]
				set idx1 [string first "/cygdrive/" $line]
				while {$idx1 >= 0} {
					set idx2 [string first "/mkisofs:" $line $idx1]
					incr idx2
					incr idx1 -1
					set line [string range $line 0 $idx1][string range $line $idx2 end]
					set idx1 [string first "/cygdrive/" $line]
				}
			}
			set data $data$line\n
		}
	}
	close $in
	return $data
}


proc update_progresbar {w pc} {
	if {[info exists ::burn::progressbar_item]} {
		$w delete $::burn::progressbar_item
	}
	set x [expr {round((([winfo width $w]-5)/100.0)*$pc)}]
	set ::burn::progressbar_item [$w create rectangle 0 0 $x 20 -fill blue]
}

proc save_setups {} {
	set txt "# PgcEdit Burn config file.  Saved automatically.  Do not edit!\n"
	if {$::tcl_platform(platform) == "windows"} {
		set txt "${txt}\nset ::burn::mkisofspath [list $::burn::mkisofspath]"
		set txt "${txt}\nset ::burn::imgburnpath [list $::burn::imgburnpath]"
		set txt "${txt}\nset ::burn::daemonpath [list $::burn::daemonpath]"
		set txt "${txt}\nset ::burn::splitoutput [list $::burn::splitoutput]"
		set txt "${txt}\nset ::burn::burnerletter [list $::burn::burnerletter]"
	}
	set txt "${txt}\nset ::burn::sldisksize $::burn::sldisksize"
	set txt "${txt}\nset ::burn::dldisksize $::burn::dldisksize"
	set txt "${txt}\nset ::burn::layer_break_sector $::burn::layer_break_sector"
	set txt "${txt}\n"
	saveFile [file join $::config(config_directory) "burn.cfg"] auto $txt
}

proc dvd_rom_size {rootdir} {
	if {[catch {set allfiles [glob -nocomplain -tails -directory $rootdir -- *]}]} {
		return [list 0 0]
	}
	set nonromfiles [glob -directory $rootdir -nocomplain -tails -- \
			VIDEO_TS AUDIO_TS *backup* *Backup* "Copy of *" .DS_Store]
	foreach f $nonromfiles {
		set idx [lsearch $allfiles $f]
		set allfiles [lreplace $allfiles $idx $idx]
	}
	set sectors 0
	set entriessectors 0
	foreach f $allfiles {
		set filename [file join $rootdir $f]
		if {[file type $filename] == "file"} {
			incr entriessectors
			incr sectors [expr {round(ceil([file size $filename]/2048.0))}]
		} else {
			set tmp [dvd_rom_size_subdir $filename]
			incr entriessectors 3
			incr entriessectors [lindex $tmp 1]
			incr sectors [lindex $tmp 0]
		}
	}
	return [list $sectors $entriessectors]
}
proc dvd_rom_size_subdir {dir} {
	if {[catch {set allfiles [glob -nocomplain -tails -directory $dir -- *]}]} {
		return [list 0 0]
	}
	set sectors 0
	set entriessectors 0
	foreach f $allfiles {
		set filename [file join $dir $f]
		if {[file type $filename] == "file"} {
			incr entriessectors
			incr sectors [expr {round(ceil([file size $filename]/2048.0))}]
		} else {
			set tmp [dvd_rom_size_subdir $filename]
			incr entriessectors 3
			incr entriessectors [lindex $tmp 1]
			incr sectors [lindex $tmp 0]
		}
	}
	return [list $sectors $entriessectors]
}

proc get_free_disk_space {path} {
	if {[file exists $path]} {
		if {[string toupper [file extension $path]] == ".ISO"} {
			set sectorsusedbyoldfile [expr {[file size $path]/2048}]
		} else {
			set rootname [file rootname $path]
			set sectorsusedbyoldfile 0
			for {set i 0} {$i < 100} {incr i} {
				set siso $rootname.ISO_[format %02d $i]
				if {[file exists $siso]} {
					incr sectorsusedbyoldfile [expr {[file size $siso]/2048}]
				} else {
					break
				}
			}
		}
	} else {
		set sectorsusedbyoldfile 0
	}
	if {$::tcl_platform(platform) == "windows"} {
		set path [string toupper [string range [file nativename [file normalize $path]] 0 1]]
		if {[catch {set txt [exec -- cmd.exe /c dir /-c $path]}]} {return -1}
		set words [lreplace [split [string trim [lindex [split [string trim $txt \n] \n] end] " "]] 0 0]
		set free ""
		foreach w $words {
			if {$w != "" && [catch {set free [expr {$w*1}]}]==0} break
		}
		if {$free == ""} {return -1}
		set free [expr {round(floor($free/2048.0))+$sectorsusedbyoldfile}]
	
		# keep some free space on system disk for windows.
		set rootdir "C:"
		foreach i {C: D: E: F: G: H: I: J: K: L: M: N: O: P: Q: R: S: T: U: V: W: X: Y: Z:} {
			if {[file exists $i]} {
				set rootdir "$i"
				break
			}
		}
	} else {
		set rootdir [file dirname $path]
		set fh [open "|df -k \"$rootdir\" | grep / | awk \"{print \$4}\""]
		set k [gets $fh]
		catch {close $fh}
		if {$k == ""} {return -1}
		set free [expr ($k/2)+$sectorsusedbyoldfile]
		set path $rootdir
	}
	if {$path == $rootdir} {
		incr free -51200
	} else {
		incr free -10240
	}
	if {$free == -1} {set free -2}
	return $free
}

proc mkisofs_version {path showversion} {
	set w .burn
	if {[winfo exists .burnsetup] && [winfo ismapped .burnsetup]} {set w .burnsetup}
	if {[catch {set fh [open "|\"[string map {\\ /} $path]\" -version" r]} errstr]} {
		tk_messageBox -title "PgcEdit: Burn DVD" -icon error \
				-message "Error retrieving the version number of mkisofs!\n$errstr" \
				-parent $w -type ok 
		set mkisofsversionstring "mkisofs - unknown version!"
		set error true
	} else {
		set mkisofsversionstring [gets $fh]
		if {$showversion} {
			tk_messageBox -title "PgcEdit: Burn DVD" -icon info \
					-message "$mkisofsversionstring\n\nYou need v2.01 or more." \
					-parent $w -type ok 
		}
	}
	catch {close $fh}
	return $mkisofsversionstring
}

}	;# End of namespace ::burn
